<?php

declare(strict_types=1);

namespace Monsun\Bugtest\Tests\Unit\Domain\Model;

use PHPUnit\Framework\MockObject\MockObject;
use TYPO3\TestingFramework\Core\AccessibleObjectInterface;
use TYPO3\TestingFramework\Core\Unit\UnitTestCase;

/**
 * Test case
 *
 * @author Dr. Dieter Porth <porth@monun-media.com>
 */
class TestmodelTest extends UnitTestCase
{
    /**
     * @var \Monsun\Bugtest\Domain\Model\Testmodel|MockObject|AccessibleObjectInterface
     */
    protected $subject;

    protected function setUp(): void
    {
        parent::setUp();

        $this->subject = $this->getAccessibleMock(
            \Monsun\Bugtest\Domain\Model\Testmodel::class,
            ['dummy']
        );
    }

    protected function tearDown(): void
    {
        parent::tearDown();
    }

    /**
     * @test
     */
    public function getOneReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getOne()
        );
    }

    /**
     * @test
     */
    public function setOneForStringSetsOne(): void
    {
        $this->subject->setOne('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('one'));
    }

    /**
     * @test
     */
    public function getTwoReturnsInitialValueForString(): void
    {
        self::assertSame(
            '',
            $this->subject->getTwo()
        );
    }

    /**
     * @test
     */
    public function setTwoForStringSetsTwo(): void
    {
        $this->subject->setTwo('Conceived at T3CON10');

        self::assertEquals('Conceived at T3CON10', $this->subject->_get('two'));
    }
}
